# config.mk
#
# Product-specific compile-time definitions.
#

# Disable DLKMs compilation for msmnile_au
TARGET_KERNEL_DLKM_DISABLE := false
#Enable legacy path for ELITE
ENABLE_AUDIO_LEGACY_TECHPACK := true

#Generate DTBO image
BOARD_KERNEL_SEPARATED_DTBO := false


### Dynamic partition Handling
ifneq ($(strip $(BOARD_DYNAMIC_PARTITION_ENABLE)),true)
  ifeq ($(ENABLE_VENDOR_IMAGE), true)
      BOARD_VENDORIMAGE_PARTITION_SIZE := 1073741824
  endif
  BOARD_SYSTEMIMAGE_PARTITION_SIZE := 3221225472
  BOARD_BUILD_SYSTEM_ROOT_IMAGE := true
  ifeq ($(ENABLE_AB), true)
      TARGET_NO_RECOVERY := true
      BOARD_USES_RECOVERY_AS_BOOT := true
  else
      BOARD_RECOVERYIMAGE_PARTITION_SIZE := 0x04000000
  endif
else
  # System_ext support
  TARGET_COPY_OUT_SYSTEM_EXT := system_ext
  BOARD_SYSTEM_EXTIMAGE_FILE_SYSTEM_TYPE := ext4

  # System DLKM dynamic Partition support
  BOARD_USES_SYSTEM_DLKMIMAGE := true
  TARGET_COPY_OUT_SYSTEM_DLKM := system_dlkm
  BOARD_SYSTEM_DLKMIMAGE_FILE_SYSTEM_TYPE := ext4

  # Vendor DLKM dynamic partition support
  BOARD_USES_VENDOR_DLKMIMAGE := true
  BOARD_VENDOR_DLKMIMAGE_FILE_SYSTEM_TYPE := ext4
  TARGET_COPY_OUT_VENDOR_DLKM := vendor_dlkm

  # Define the Dynamic Partition sizes and groups.
  ifeq ($(ENABLE_AB), true)
    BOARD_SUPER_PARTITION_SIZE := 12884901888
  else
    BOARD_SUPER_PARTITION_SIZE := 5318967296
  endif
  BOARD_SUPER_PARTITION_GROUPS := qti_dynamic_partitions
  BOARD_QTI_DYNAMIC_PARTITIONS_SIZE := 5314772992
  BOARD_QTI_DYNAMIC_PARTITIONS_PARTITION_LIST := system vendor system_ext vendor_dlkm system_dlkm
  BOARD_RECOVERYIMAGE_PARTITION_SIZE := 67108864
  BOARD_EXT4_SHARE_DUP_BLOCKS := true
endif

ifeq ($(BOARD_KERNEL_SEPARATED_DTBO),true)
    # Enable DTBO for recovery image
    BOARD_INCLUDE_RECOVERY_DTBO := true
endif
### Dynamic partition Handling

TARGET_ARCH := arm64
TARGET_ARCH_VARIANT := armv8-a
TARGET_CPU_ABI := arm64-v8a
TARGET_CPU_ABI2 :=
TARGET_CPU_VARIANT := generic

TARGET_2ND_ARCH := arm
TARGET_2ND_ARCH_VARIANT := armv7-a-neon
TARGET_2ND_CPU_ABI := armeabi-v7a
TARGET_2ND_CPU_ABI2 := armeabi
TARGET_2ND_CPU_VARIANT := cortex-a9

TARGET_SEPOLICY_DIR := gen3_metal

BOARD_SECCOMP_POLICY := device/qcom/$(TARGET_BOARD_PLATFORM)/seccomp

TARGET_AUDIO_FRAMEWORK := elite

TARGET_NO_BOOTLOADER := false
TARGET_USES_UEFI := true
TARGET_NO_KERNEL := false

TARGET_USES_IOPHAL := true

BUILD_BROKEN_DUP_RULES := true

BOARD_RAMDISK_USE_LZ4 := true

-include $(QCPATH)/common/gen4_au/BoardConfigVendor.mk

# Some framework code requires this to enable BT
BOARD_HAVE_BLUETOOTH := true
BOARD_USES_WIPOWER := true
BOARD_BLUETOOTH_BDROID_BUILDCFG_INCLUDE_DIR := device/qcom/common/automotive

USE_OPENGL_RENDERER := true
BOARD_USE_LEGACY_UI := true

# Set Header version for bootimage
#Disable appended dtb
TARGET_KERNEL_APPEND_DTB := false

#Enable dtb in boot image and boot image header version 3 support.
BOARD_INCLUDE_DTB_IN_BOOTIMG := true
ifeq ($(ENABLE_AB), true)
BOARD_USES_RECOVERY_AS_BOOT := false
TARGET_NO_RECOVERY := true
endif

BOARD_BOOT_HEADER_VERSION := 4
BOARD_MKBOOTIMG_ARGS := --header_version $(BOARD_BOOT_HEADER_VERSION)

ifeq ($(TARGET_NO_RECOVERY), true)
BOARD_MOVE_RECOVERY_RESOURCES_TO_VENDOR_BOOT := true
BOARD_INCLUDE_RECOVERY_RAMDISK_IN_VENDOR_BOOT := true
endif
# Specify init boot header version
BOARD_INIT_BOOT_HEADER_VERSION := 4
BOARD_MKBOOTIMG_INIT_ARGS += --header_version $(BOARD_INIT_BOOT_HEADER_VERSION)
# Defines for enabling A/B builds
AB_OTA_UPDATER := true
# Full A/B partition update set
# AB_OTA_PARTITIONS := xbl rpm tz hyp pmic modem abl boot keymaster cmnlib cmnlib64 system bluetooth

# Minimum partition set for automation to test recovery generation code
# Packages generated by using just the below flag cannot be used for updating a device. You must pass
# in the full set mentioned above as part of your make commandline
AB_OTA_PARTITIONS ?= system vendor system_ext vendor_dlkm system_dlkm
#TARGET_NO_RECOVERY := true
#BOARD_USES_RECOVERY_AS_BOOT := true
BOARD_USES_METADATA_PARTITION := true

#Enable compilation of oem-extensions to recovery
#These need to be explicitly 
ifneq ($(AB_OTA_UPDATER),true)
    TARGET_RECOVERY_UPDATER_LIBS += librecovery_updater_msm
endif

ifneq ($(strip $(BOARD_DYNAMIC_PARTITION_ENABLE)),true)
  TARGET_RECOVERY_FSTAB := device/qcom/gen4_au/fstab.qcom
else
  TARGET_RECOVERY_FSTAB := device/qcom/gen4_au/fstab.qcom
endif


#Enable split vendor image
ENABLE_VENDOR_IMAGE := true
ifeq ($(ENABLE_VENDOR_IMAGE), true)
#BOARD_VENDORIMAGE_PARTITION_SIZE := 1073741824
BOARD_VENDORIMAGE_FILE_SYSTEM_TYPE := ext4
TARGET_COPY_OUT_VENDOR := vendor
BOARD_PROPERTY_OVERRIDES_SPLIT_ENABLED := true
endif
TARGET_USERIMAGES_USE_EXT4 := true
TARGET_USERIMAGES_USE_F2FS := true
BOARD_BOOTIMAGE_PARTITION_SIZE := 0x04000000
BOARD_KERNEL-GKI_BOOTIMAGE_PARTITION_SIZE := $(BOARD_BOOTIMAGE_PARTITION_SIZE)
BOARD_VENDOR_BOOTIMAGE_PARTITION_SIZE := 0x06000000
BOARD_INIT_BOOT_IMAGE_PARTITION_SIZE := 0x00800000
#BOARD_SYSTEMIMAGE_PARTITION_SIZE := 3221225472
BOARD_USERDATAIMAGE_PARTITION_SIZE := 10737418240
BOARD_PERSISTIMAGE_PARTITION_SIZE := 33554432
BOARD_METADATAIMAGE_PARTITION_SIZE := 16777216
BOARD_PREBUILT_DTBOIMAGE := out/target/product/gen4_au/prebuilt_dtbo.img
BOARD_DTBOIMG_PARTITION_SIZE := 0x0800000
BOARD_PERSISTIMAGE_FILE_SYSTEM_TYPE := ext4
BOARD_FLASH_BLOCK_SIZE := 131072 # (BOARD_KERNEL_PAGESIZE * 64)
BOARD_USERDATAIMAGE_FILE_SYSTEM_TYPE := f2fs

BOARD_VENDOR_KERNEL_MODULES := \
#    $(KERNEL_MODULES_OUT)/hsi2s.ko
#    $(KERNEL_MODULES_OUT)/audio_apr.ko \
#    $(KERNEL_MODULES_OUT)/audio_snd_event.ko \
#    $(KERNEL_MODULES_OUT)/audio_q6_notifier.ko \
#    $(KERNEL_MODULES_OUT)/audio_adsp_loader.ko \
#    $(KERNEL_MODULES_OUT)/audio_q6.ko \
#    $(KERNEL_MODULES_OUT)/audio_platform.ko \
#    $(KERNEL_MODULES_OUT)/audio_hdmi.ko \
#    $(KERNEL_MODULES_OUT)/audio_stub.ko \
#    $(KERNEL_MODULES_OUT)/audio_native.ko \
#    $(KERNEL_MODULES_OUT)/audio_machine_msmnile.ko \
#    $(KERNEL_MODULES_OUT)/wil6210.ko \
#    $(KERNEL_MODULES_OUT)/msm_11ad_proxy.ko \
#    $(KERNEL_MODULES_OUT)/emac_dwc_eqos.ko \

# install lkdtm only for userdebug and eng build variants
ifneq (,$(filter userdebug eng, $(TARGET_BUILD_VARIANT)))
    ifneq (,$(findstring debug_defconfig, $(KERNEL_DEFCONFIG)))
#         BOARD_VENDOR_KERNEL_MODULES += $(KERNEL_MODULES_OUT)/lkdtm.ko
    endif
endif



BOARD_DO_NOT_STRIP_VENDOR_MODULES := true

BOARD_VENDOR_KERNEL_MODULES += $(shell ls $(KERNEL_MODULES_OUT)/*.ko)
TARGET_USES_ION := true
TARGET_USES_NEW_ION_API :=true
TARGET_USES_QCOM_BSP := false

BOARD_BOOTCONFIG := androidboot.hardware=qcom androidboot.memcg=1 androidboot.usbcontroller=a600000.dwc3 androidboot.recover_usb=1 androidboot.load_modules_parallel=true

BOARD_KERNEL_CMDLINE := lpm_levels.sleep_disabled=1 video=vfb:640x400,bpp=32,memsize=3072000 msm_rtb.filter=0x237 service_locator.enable=1 swiotlb=4096 firmware_class.path=/vendor/firmware_mnt/image loop.max_part=7 kvm-arm.mode=nvhe hibernate=nocompress noswap_randomize pcie_ports=compat loglevel=8 printk.devkmsg=on
BOARD_BOOTCONFIG += androidboot.audio=audioreach
ifeq ($(TARGET_CONSOLE_ENABLED),true)
BOARD_KERNEL_CMDLINE += console=ttyMSM0,115200n8 earlycon=qcom_geni,0xa90000 qcom_geni_serial.con_enabled=1
BOARD_BOOTCONFIG += androidboot.console=ttyMSM0
BOARD_KERNEL_CMDLINE += slub_debug=FZPU
else
ifeq ($(TARGET_CONSOLE_ENABLED),false)
BOARD_KERNEL_CMDLINE += qcom_geni_serial.con_enabled=0
endif
endif

BOARD_EGL_CFG := device/qcom/$(TARGET_BOARD_PLATFORM)/egl.cfg

BOARD_KERNEL_BASE        := 0x00000000
BOARD_KERNEL_PAGESIZE    := 4096
BOARD_KERNEL_TAGS_OFFSET := 0x01E00000
BOARD_RAMDISK_OFFSET     := 0x02000000

TARGET_KERNEL_ARCH := arm64
TARGET_KERNEL_HEADER_ARCH := arm64
TARGET_KERNEL_CROSS_COMPILE_PREFIX := $(shell pwd)/prebuilts/gcc/linux-x86/aarch64/aarch64-linux-android-4.9/bin/aarch64-linux-androidkernel-

MAX_EGL_CACHE_KEY_SIZE := 12*1024
MAX_EGL_CACHE_SIZE := 2048*1024

BOARD_USES_GENERIC_AUDIO := true
BOARD_QTI_CAMERA_32BIT_ONLY := true
TARGET_NO_RPC := true

TARGET_PLATFORM_DEVICE_BASE := /devices/soc.0/
TARGET_INIT_VENDOR_LIB := libinit_msm

TARGET_USES_REMOTEPROC := true
BOARD_EXT4_SHARE_DUP_BLOCKS := true
TARGET_COMPILE_WITH_MSM_KERNEL := false
TARGET_SIGNONLY_BOOTLOADER := true

#Enable PD locater/notifier
TARGET_PD_SERVICE_ENABLED := true

#Enable peripheral manager
TARGET_PER_MGR_ENABLED := true

# Enable dex pre-opt to speed up initial boot
ifeq ($(HOST_OS),linux)
    ifeq ($(WITH_DEXPREOPT),)
      WITH_DEXPREOPT := true
      WITH_DEXPREOPT_PIC := true
      ifneq ($(TARGET_BUILD_VARIANT),user)
        # Retain classes.dex in APK's for non-user builds
        DEX_PREOPT_DEFAULT := nostripping
      endif
    endif
endif

TARGET_USES_GRALLOC1 := true

# Enable sensor multi HAL
USE_SENSOR_MULTI_HAL := false

# Enable sensor Version V_1
USE_SENSOR_HAL_VER := 1.0

#Add non-hlos files to ota packages
ADD_RADIO_FILES := true

#Enable INTERACTION_BOOST
TARGET_USES_INTERACTION_BOOST := true

#Enable DRM plugins 64 bit compilation
TARGET_ENABLE_MEDIADRM_64 := true

#namespace definition for librecovery_updater
#differentiate legacy 'sg' or 'bsg' framework
SOONG_CONFIG_NAMESPACES += ufsbsg
SOONG_CONFIG_ufsbsg += ufsframework
SOONG_CONFIG_ufsbsg_ufsframework := bsg

#namespace definition for qtiwifi
#differentiate auto and non-auto target
SOONG_CONFIG_NAMESPACES += qtiwifi
SOONG_CONFIG_qtiwifi += automobile
SOONG_CONFIG_qtiwifi_automobile := true

#enable 64bit audioservice
SOONG_CONFIG_NAMESPACES += android_hardware_audio
SOONG_CONFIG_android_hardware_audio += run_64bit
SOONG_CONFIG_android_hardware_audio_run_64bit := true

#----------------------------------------------------------------------
# wlan specific
#----------------------------------------------------------------------
ifeq ($(strip $(TARGET_KERNEL_DLKM_DISABLE)),true)
#Uncomment the following to override dlkm disabling
#TARGET_KERNEL_DLKM_OVERRIDE += wlan-platform-module-symvers \
#			       cnss2.ko \
#			       cnss_plat_ipc_qmi_svc.ko \
#			       wlan_firmware_service.ko \
#			       cnss_nl.ko \
#			       cnss_utils.ko
#TARGET_KERNEL_DLKM_OVERRIDE += $(foreach chip, $(TARGET_WLAN_CHIP), $(WLAN_CHIPSET)_$(chip).ko)
endif

ifeq ($(strip $(BOARD_HAS_QCOM_WLAN)),true)
include device/qcom/wlan/gen4_au/BoardConfigWlan.mk
endif

#Flag to enable System SDK Requirements.
#All vendor APK will be compiled against system_current API set.
BOARD_SYSTEMSDK_VERSIONS:= 33

#Enable VNDK Compliance
BOARD_VNDK_VERSION:=current

BUILD_BROKEN_NINJA_USES_ENV_VARS := SDCLANG_AE_CONFIG SDCLANG_CONFIG SDCLANG_SA_ENABLED SDCLANG_CONFIG_AOSP
BUILD_BROKEN_PREBUILT_ELF_FILES := true
BUILD_BROKEN_USES_BUILD_HOST_SHARED_LIBRARY := true
BUILD_BROKEN_USES_BUILD_HOST_EXECUTABLE := true
BUILD_BROKEN_USES_BUILD_COPY_HEADERS := true
BUILD_BROKEN_USES_BUILD_HOST_STATIC_LIBRARY := true
BUILD_BROKEN_CLANG_PROPERTY := true  #bringup
#Flag for Early Ethernet
IS_EARLY_ETH_ENABLED := 1

#################################################################################
# This is the End of BoardConfig.mk file.
# Now, Pickup other split Board.mk files:
#################################################################################
# TODO: Relocate the system Board.mk files pickup into qssi lunch, once it is up.
-include vendor/qcom/defs/board-defs/system/*.mk
-include vendor/qcom/defs/board-defs/vendor/*.mk
#################################################################################
include device/qcom/sepolicy_vndr/SEPolicy.mk
#Enable Camera2 APIs on automotive builds
ENABLE_CAMERA_SERVICE := true
